
/*
           
*/
#property copyright   ""
#property link        ""
#property description "CCI_Semafor"
#property strict



#property indicator_chart_window

#property indicator_buffers    3


input int      CCIPeriod1   = 14; // CCI Period
input int      CCIPeriod2   = 42; // CCI Period
input int      CCIPeriod3   = 210; // CCI Period

 double  Level          = 100;

double BufCCI1[];
double BufCCI2[];
double BufCCI3[];


string MyName = "";
int UninitR;
string BgrImgLabName;
string Lamp1ImgLabName;
string Lamp2ImgLabName;
string Lamp3ImgLabName;
string LampRedImg       = "n_red2Small.bmp";
string LampGreenImg     = "n_green2Small.bmp";
string LampBlueImg      = "n_blue2Small.bmp";
string VLineName;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   UninitR = UninitializeReason() ;
   DelMyObj(MyName);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(void)
  {
   string short_name;

   short_name="CCI_Semafor ("  + IntegerToString(CCIPeriod1) + ", " + IntegerToString(CCIPeriod2) + ", " + IntegerToString(CCIPeriod3) +  ")";
   MyName = "CCI_Semafor_";
   
    BgrImgLabName    =  MyName + "SemaforBgr"; //    -   
    Lamp1ImgLabName  =  MyName + "Lamp1"; 
    Lamp2ImgLabName  =  MyName + "Lamp2"; 
    Lamp3ImgLabName  =  MyName + "Lamp3";  
    VLineName        =  MyName + "Vline";
   IndicatorBuffers(3);
   SetIndexBuffer(0,BufCCI1);
   SetIndexBuffer(1,BufCCI2);
   SetIndexBuffer(2,BufCCI3);
   

   if(CCIPeriod1<=1)
     {
      Print("Wrong input parameter CCI Period=",CCIPeriod1);
      return(INIT_FAILED);
     }
//---
   SetIndexDrawBegin(0,CCIPeriod1);

   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   //DRAW_LINE
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexStyle(2,DRAW_NONE);
   
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
   
//--- initialization done
   DrawBGRsvet();
   return(INIT_SUCCEEDED);
  }
  
//=======================================================================
//
//=======================================================================  
int start()
{

   int i,limit,counted_bars=IndicatorCounted();
   int uptrending=0,downtrending=0;
//---- TODO: add your code here
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
 
   for(i=0; i<limit; i++)
   {
      BufCCI1[i]=iCCI(NULL,0,CCIPeriod1,PRICE_TYPICAL,i);
      BufCCI2[i]=iCCI(NULL,0,CCIPeriod2,PRICE_TYPICAL,i);
      BufCCI3[i]=iCCI(NULL,0,CCIPeriod3,PRICE_TYPICAL,i);
   }

   bool stateON = ObjectGetInteger(0,BgrImgLabName,OBJPROP_STATE);
   if(!stateON)
   {
   for(int nLamp = 1; nLamp<=3; nLamp++)
      DrawLamps(nLamp,0);
   //DrawLamps(1,0);
   }
   
   return(0);
  }


//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
        
   bool stateON = ObjectGetInteger(0,BgrImgLabName,OBJPROP_STATE);
   int i,k;
   //
   if(stateON)
   {
        
        if(id == CHARTEVENT_MOUSE_MOVE)      // .   init ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
        //
        {
              Print("stateON = ",stateON); 
               int      x     =(int)lparam;
               int      y     =(int)dparam;
               datetime dt    =0;
               double   price =0;
               int      window=0;
      
               if(ChartXYToTimePrice(0,x,y,window,dt,price))
               {
                  i = iBarShift(NULL, 0, dt, true);
                  
                  for(k = 1; k<=3; k++)
                  DrawLamps(k,  i);
                  DrawVLine(dt);
                  
                  PrintFormat("Window=%d X=%d  Y=%d  =>  Time=%s  Price=%G i=%d",window,x,y,TimeToString(dt),price,i);
                  ChartRedraw(0);
                  Sleep(5);
               }
               //else
               //   Print("ChartXYToTimePrice return error code: ",GetLastError()); //     ,  4051
               //   Print("    : x = ",lparam,"  y = ",dparam);
        }
    }
    else
    {
       ObjectDelete(VLineName);    
       
      // ChartRedraw(0);
    }
    if(id==CHARTEVENT_CLICK)
    {
         if(!stateON)
         for(int nLamp = 1; nLamp<=3; nLamp++)
         DrawLamps(nLamp,0);
         
         ChartRedraw(0);
    }
    
    
    
}
//==============================================================================
//    DrawVLine
//==============================================================================
void DrawVLine(datetime t1)
{
      int chart_ID = 0;
      string name = VLineName;
      ObjectDelete(VLineName);
      ObjectCreate(chart_ID, VLineName, OBJ_VLINE,0,t1,0);
      ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,Green);//clrDeepSkyBlue
      //---    
         ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,STYLE_DASHDOT);
      //---   
         ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,1);
      //---    (false)   (true) 
         ObjectSetInteger(chart_ID,name,OBJPROP_BACK,false);
      //---  (true)   (false)    
      //---      ObjectCreate,   
      //---    .      selection
      //---    true,       
         ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,false);
      //---  (true)   (false)      
         ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,false);
      //---         
         ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,0);  //OBJPROP_TOOLTIP
         ObjectSetString(chart_ID,name,OBJPROP_TOOLTIP, "\n" );

      
      
      
}

//==============================================================================
//    DrawLamps
//==============================================================================
void DrawLamps(int nLamp, int i)
{
   double cci = 0;
   string bmpFile;
   string labName;
   int yBase = 80;
   int xBase = 28;
   int                        width             = 64;
   int                        height            = 100;
   int                        x_offset          = 0;
   int                        y_offset          = 0;
   int                        x                 = 30;
   int                        y                 = 50;
   string                     InpFileOn         = "\\Images\\"  + "n_svet2Small_ON.bmp";
   string                     InpFileOff        = "\\Images\\"  + "n_svet2Small_OFF.bmp";
   bool                       InpState          = false;                   //  /
   const  ENUM_BASE_CORNER    InpCorner         = CORNER_RIGHT_LOWER;      //    
   const  ENUM_ANCHOR_POINT   InpAnchor         = ANCHOR_CENTER;          //  
   color                      InpColor          = clrRed;                  //    
   const  ENUM_LINE_STYLE     InpStyle          = STYLE_SOLID;             //    
   int                        InpPointWidth     = 1;                  //    
   bool                       InpBack           = false;                    //    
   bool                       InpSelectable     = false;               //   
   bool                       InpSelection      = false;               //   
   bool                       InpHidden         = false;                   //    
   long                       InpZOrder         = 0;                      //    
   
   if(nLamp == 1) {cci = BufCCI1[i];  x = xBase; y = yBase; labName = Lamp1ImgLabName;}
   if(nLamp == 2) {cci = BufCCI2[i];  x = xBase; y = yBase-23; labName = Lamp2ImgLabName;} 
   if(nLamp == 3) {cci = BufCCI3[i];  x = xBase; y = yBase -46; labName = Lamp3ImgLabName;}     
   
   
   if(cci>=100)                  bmpFile = LampGreenImg;
   if(cci < 100 && cci > -100)   bmpFile = LampBlueImg;
   if(cci < -100 )               bmpFile = LampRedImg;
   
   width             = 23;
   height            = 23;
   x_offset          = 0;
   y_offset          = 0;
   //x                 = 30;
   //y                 = 50;
   InpFileOn         = "\\Images\\"  + bmpFile;
   InpFileOff        = "\\Images\\"  + bmpFile;
   InpState          = false;                   //  /
   //InpCorner         = CORNER_RIGHT_LOWER;      //    
   //InpAnchor         = ANCHOR_CENTER;          //  
   InpColor          = clrRed;                  //    
   //InpStyle          = STYLE_SOLID;             //    
   InpPointWidth     = 1;                  //    
   InpBack           = false;                    //    
   InpSelectable     = false;               //   
   InpSelection      = false;               //   
   InpHidden         = false;                   //    
   InpZOrder         = 0;   
   
   ObjectDelete(0,labName);
   if(!BitmapLabelCreate(0,labName,0,x,y, InpFileOn, InpFileOff,width,height,x_offset,y_offset, InpState,
      InpCorner,InpAnchor,InpColor,InpStyle,InpPointWidth,InpBack, InpSelectable, InpSelection, InpHidden,InpZOrder))
     {
      Print("   ");
      return;
     }
   

}


//==============================================================================
//    DrawPic
//==============================================================================
void DrawPic(int code)
{
      
   ObjectDelete(0, BgrImgLabName);
   
   int                        width             = 64;
   int                        height            = 100;
   int                        x_offset          = 0;
   int                        y_offset          = 0;
   int                        x                 = 30;
   int                        y                 = 50;
   string                     InpFileOn         = "\\Images\\"  + "n_svet2Small_ON.bmp";
   string                     InpFileOff        = "\\Images\\"  + "n_svet2Small_OFF.bmp";
   bool                       InpState          = false;                   //  /
   const  ENUM_BASE_CORNER    InpCorner         = CORNER_RIGHT_LOWER;      //    
   const  ENUM_ANCHOR_POINT   InpAnchor         = ANCHOR_CENTER;          //  
   color                      InpColor          = clrRed;                  //    
   const  ENUM_LINE_STYLE     InpStyle          = STYLE_SOLID;             //    
   int                        InpPointWidth     = 1;                  //    
   bool                       InpBack           = false;                    //    
   bool                       InpSelectable     = false;               //   
   bool                       InpSelection      = false;               //   
   bool                       InpHidden         = false;                   //    
   long                       InpZOrder         = 0;                      //    

   if(!BitmapLabelCreate(0,BgrImgLabName,0,x,y, InpFileOn, InpFileOff,width,height,x_offset,y_offset, InpState,
      InpCorner,InpAnchor,InpColor,InpStyle,InpPointWidth,InpBack, InpSelectable, InpSelection, InpHidden,InpZOrder))
     {
      Print("   ");
      return;
     }
         

}

//+------------------------------------------------------------------+
//|   " "                               |
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,               // ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=0,              //     X
                       const int               y_offset=0,              //     Y
                       const bool              state=false,              // /
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //   
                       const color             clr=clrRed,               //    
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const int               point_width = 2,            //   
                       const bool              back=false,               //   
                       const bool              selectable = false,          //   
                       const bool              selection = false,          //   
                       const bool              hidden=false,              //    
                       const long              z_order=3)                //    
  {
//---   
   ResetLastError();
//---   
   if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ":     \" \"!   = ",GetLastError());
      return(false);
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ":       On!   = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ":       Off!   = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selectable);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
   ChartRedraw(0);
//---  
   return(true);
  }
//==============================================================================
//    DrawBGRsvet
//==============================================================================
void DrawBGRsvet()
{
      
   //string labName = MyName + "SemaforPic";
   
   ObjectDelete(0, BgrImgLabName);
   
   int width = 64;
   int height = 100;
   int x_offset= 0;
   int y_offset= 0;
   int x = 30;
   int y = 50;
   
  // string InpFileOn        = "\\Images\\sv" + IntegerToString(code) + ".bmp";
 // string InpFileOff       = "\\Images\\sv" + IntegerToString(code) + ".bmp";
   
   string                     InpFileOn         = "\\Images\\"  + "n_svet2Small_ON.bmp";
   string                     InpFileOff        = "\\Images\\"  + "n_svet2Small_OFF.bmp";
   
   
   bool                       InpState          = false;                   //  /
   const  ENUM_BASE_CORNER    InpCorner         = CORNER_RIGHT_LOWER;      //    
   const  ENUM_ANCHOR_POINT   InpAnchor         = ANCHOR_CENTER;          //  
   
   color                      InpColor          = clrRed;                  //    
   const  ENUM_LINE_STYLE     InpStyle          = STYLE_SOLID;             //    
   int                        InpPointWidth     = 1;                  //    
   bool                       InpBack           = false;                    //    
   bool                       InpSelectable     = false;               //   
   bool                       InpSelection      = false;               //   
   bool                       InpHidden         = false;                   //    
   long                       InpZOrder         = 2;                      //    

   if(!BitmapLabelCreate(0,BgrImgLabName,0,x,y, InpFileOn, InpFileOff,width,height,x_offset,y_offset, InpState,
      InpCorner,InpAnchor,InpColor,InpStyle,InpPointWidth,InpBack, InpSelectable, InpSelection, InpHidden,InpZOrder))
     {
      Print("   ");
      return;
     }
         

}

//===============================================================================
//     ,    
//   -  
//===============================================================================
void DelMyObj(string myName)
{
int pos, pos2;
string objName;
int    obj_total=ObjectsTotal();
         
      for(int i=obj_total-1;i>=0; i--)
      {
         objName = ObjectName(i);
         pos = StringFind(objName, myName, 0);
         if(pos!=-1) 
         {
            //UninitR
            pos2 = StringFind(objName, "MedianMain", 0);
            if(pos2 == -1 || UninitR == REASON_REMOVE) 
            ObjectDelete(objName);
         }
      }
//return(0);
}

