//+------------------------------------------------------------------+
//|                                                          CCI.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
/*
       CCI    http://forexsystems.ru/ruchnye-torgovye-strategii-i-taktiki/74292-haos-visual-ssrc_mtf-pipsovka-dlya-vseh-34.html#post861833
      3.1  
      3.2        
*/
#property copyright   ""
#property link        ""
#property description "Commodity Channel Index"
#property strict

//#include <MovingAverages.mqh>

#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     LightSeaGreen
#property indicator_level1    -100.0
#property indicator_level2     100.0
#property indicator_level3     0.0
#property indicator_level4     200.0
#property indicator_level5     -200.0
#property indicator_levelcolor clrSilver
#property indicator_levelstyle STYLE_DOT
//--- input parameter
input int      InpCCIPeriod   = 14; // CCI Period
extern double  Level          = 100;
extern double  SigDeviat      = 100;
extern color   ClrUp          = clrLime;
extern color   ClrDn          = clrRed;
extern color   ClrNeutral     = clrDodgerBlue;
extern color   ClrSignal      = clrYellow;
extern int     HistWidth      = 3;
//--- buffers
//--- buffers
//--- buffers
double BufCCI[];

double BufUp[];
double BufDn[];
double BufNe[];
double BufSignal[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(void)
  {
   string short_name;
//--- 2 additional buffers are used for counting.
   IndicatorBuffers(5);
   SetIndexBuffer(0,BufUp);
   SetIndexBuffer(1,BufDn);
   SetIndexBuffer(2,BufNe);
   SetIndexBuffer(3,BufCCI);
   SetIndexBuffer(4,BufSignal);
   

   if(InpCCIPeriod<=1)
     {
      Print("Wrong input parameter CCI Period=",InpCCIPeriod);
      return(INIT_FAILED);
     }
//---
   SetIndexDrawBegin(0,InpCCIPeriod);
//--- name for DataWindow and indicator subwindow label
   short_name="CCI__v3.4 ("+IntegerToString(InpCCIPeriod)+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
   
   
   
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,HistWidth,ClrUp);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,HistWidth,ClrDn);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,HistWidth,ClrNeutral);
   
   //SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1, clrLavender);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,HistWidth,ClrSignal);
   
//--- initialization done
   return(INIT_SUCCEEDED);
  }
  
//=======================================================================
//
//=======================================================================  
int start()
{
   double curr, prev;
   int i,limit,counted_bars=IndicatorCounted();
   int uptrending=0,downtrending=0;
//---- TODO: add your code here
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   bool precondBuy = false, precondSell = false;
   
//---- main loop
   
   //limit = Bars-1;
   //for(i=limit; i>=0; i--)
   for(i=0; i<limit; i++)
   {
      BufCCI[i]=iCCI(NULL,0,InpCCIPeriod,PRICE_TYPICAL,i);
      BufNe[i] = 0;
      BufUp[i] = 0;
      BufDn[i] = 0;
   }
   //for(i=0; i<limit; i++)
   for(i=limit; i>=0; i--)
   {
      if(i<=Bars-3)
      {
             curr = BufCCI[i];
             prev = BufCCI[i+1];
            
            
            
            
            if(curr > 0)
            { 
            
                  if(curr >= Level )
                  {
                     BufNe[i] = Level;
                     BufUp[i] = curr;
                     BufDn[i] = 0;
                  }
                 
                  if(curr <= Level )
                  {
                     BufNe[i] = curr;
                     BufUp[i] = 0;
                     BufDn[i] = 0;
                  }
                  
                 
                  
            
            }
            //---------------------------------------------------------------------------
            if(curr<= 0)
            { 
                     if(curr < -Level )
                     {
                        BufNe[i] = -Level;
                        BufUp[i] = 0;
                        BufDn[i] = curr;
                     }
                     if(curr >= -Level )
                     {
                        BufNe[i] = curr;
                        BufUp[i] = 0;
                        BufDn[i] = 0;
                     }
                    
            }
          
            
      }
    //if(i==0)
     //Print("  BufNe[i] = ", BufNe[i],  "  BufUp[i] = ", BufUp[i],"  BufDn[i] = ", BufDn[i]);
      
   }
   //***************************
   limit = Bars-2;
   for(i=limit; i>=0; i--)
   {
             BufSignal[i] = 0;
             curr = BufCCI[i];
             prev = BufCCI[i+1];
      if(curr >= Level + SigDeviat)
            {
               precondSell = true;
            }
            if(precondSell && prev >= Level && curr < Level)
            {
               BufSignal[i] = curr;
               precondSell = false;
            }
            
            if(curr <= -Level - SigDeviat)
            {
               precondBuy = true;
            }
            if(precondBuy && prev <= -Level && curr > -Level)
            {
               BufSignal[i] = curr;
               precondBuy = false;
            }
      
      
             
   }   
   return(0);
  }
//+------------------------------------------------------------------+
